/*
BotV2

Bot API v2

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package botapiv2

import (
	"encoding/json"
)

// checks if the ResponseWait type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ResponseWait{}

// ResponseWait struct for ResponseWait
type ResponseWait struct {
	Enabled *bool `json:"enabled,omitempty"`
	Duration *string `json:"duration,omitempty"`
	Reminders []Reminder `json:"reminders,omitempty"`
	Validation *Validation `json:"validation,omitempty"`
	Writers []Writer `json:"writers,omitempty"`
}

// NewResponseWait instantiates a new ResponseWait object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewResponseWait() *ResponseWait {
	this := ResponseWait{}
	return &this
}

// NewResponseWaitWithDefaults instantiates a new ResponseWait object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewResponseWaitWithDefaults() *ResponseWait {
	this := ResponseWait{}
	return &this
}

// GetEnabled returns the Enabled field value if set, zero value otherwise.
func (o *ResponseWait) GetEnabled() bool {
	if o == nil || IsNil(o.Enabled) {
		var ret bool
		return ret
	}
	return *o.Enabled
}

// GetEnabledOk returns a tuple with the Enabled field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ResponseWait) GetEnabledOk() (*bool, bool) {
	if o == nil || IsNil(o.Enabled) {
		return nil, false
	}
	return o.Enabled, true
}

// HasEnabled returns a boolean if a field has been set.
func (o *ResponseWait) HasEnabled() bool {
	if o != nil && !IsNil(o.Enabled) {
		return true
	}

	return false
}

// SetEnabled gets a reference to the given bool and assigns it to the Enabled field.
func (o *ResponseWait) SetEnabled(v bool) {
	o.Enabled = &v
}

// GetDuration returns the Duration field value if set, zero value otherwise.
func (o *ResponseWait) GetDuration() string {
	if o == nil || IsNil(o.Duration) {
		var ret string
		return ret
	}
	return *o.Duration
}

// GetDurationOk returns a tuple with the Duration field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ResponseWait) GetDurationOk() (*string, bool) {
	if o == nil || IsNil(o.Duration) {
		return nil, false
	}
	return o.Duration, true
}

// HasDuration returns a boolean if a field has been set.
func (o *ResponseWait) HasDuration() bool {
	if o != nil && !IsNil(o.Duration) {
		return true
	}

	return false
}

// SetDuration gets a reference to the given string and assigns it to the Duration field.
func (o *ResponseWait) SetDuration(v string) {
	o.Duration = &v
}

// GetReminders returns the Reminders field value if set, zero value otherwise.
func (o *ResponseWait) GetReminders() []Reminder {
	if o == nil || IsNil(o.Reminders) {
		var ret []Reminder
		return ret
	}
	return o.Reminders
}

// GetRemindersOk returns a tuple with the Reminders field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ResponseWait) GetRemindersOk() ([]Reminder, bool) {
	if o == nil || IsNil(o.Reminders) {
		return nil, false
	}
	return o.Reminders, true
}

// HasReminders returns a boolean if a field has been set.
func (o *ResponseWait) HasReminders() bool {
	if o != nil && !IsNil(o.Reminders) {
		return true
	}

	return false
}

// SetReminders gets a reference to the given []Reminder and assigns it to the Reminders field.
func (o *ResponseWait) SetReminders(v []Reminder) {
	o.Reminders = v
}

// GetValidation returns the Validation field value if set, zero value otherwise.
func (o *ResponseWait) GetValidation() Validation {
	if o == nil || IsNil(o.Validation) {
		var ret Validation
		return ret
	}
	return *o.Validation
}

// GetValidationOk returns a tuple with the Validation field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ResponseWait) GetValidationOk() (*Validation, bool) {
	if o == nil || IsNil(o.Validation) {
		return nil, false
	}
	return o.Validation, true
}

// HasValidation returns a boolean if a field has been set.
func (o *ResponseWait) HasValidation() bool {
	if o != nil && !IsNil(o.Validation) {
		return true
	}

	return false
}

// SetValidation gets a reference to the given Validation and assigns it to the Validation field.
func (o *ResponseWait) SetValidation(v Validation) {
	o.Validation = &v
}

// GetWriters returns the Writers field value if set, zero value otherwise.
func (o *ResponseWait) GetWriters() []Writer {
	if o == nil || IsNil(o.Writers) {
		var ret []Writer
		return ret
	}
	return o.Writers
}

// GetWritersOk returns a tuple with the Writers field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ResponseWait) GetWritersOk() ([]Writer, bool) {
	if o == nil || IsNil(o.Writers) {
		return nil, false
	}
	return o.Writers, true
}

// HasWriters returns a boolean if a field has been set.
func (o *ResponseWait) HasWriters() bool {
	if o != nil && !IsNil(o.Writers) {
		return true
	}

	return false
}

// SetWriters gets a reference to the given []Writer and assigns it to the Writers field.
func (o *ResponseWait) SetWriters(v []Writer) {
	o.Writers = v
}

func (o ResponseWait) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ResponseWait) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Enabled) {
		toSerialize["enabled"] = o.Enabled
	}
	if !IsNil(o.Duration) {
		toSerialize["duration"] = o.Duration
	}
	if !IsNil(o.Reminders) {
		toSerialize["reminders"] = o.Reminders
	}
	if !IsNil(o.Validation) {
		toSerialize["validation"] = o.Validation
	}
	if !IsNil(o.Writers) {
		toSerialize["writers"] = o.Writers
	}
	return toSerialize, nil
}

type NullableResponseWait struct {
	value *ResponseWait
	isSet bool
}

func (v NullableResponseWait) Get() *ResponseWait {
	return v.value
}

func (v *NullableResponseWait) Set(val *ResponseWait) {
	v.value = val
	v.isSet = true
}

func (v NullableResponseWait) IsSet() bool {
	return v.isSet
}

func (v *NullableResponseWait) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableResponseWait(val *ResponseWait) *NullableResponseWait {
	return &NullableResponseWait{value: val, isSet: true}
}

func (v NullableResponseWait) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableResponseWait) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


